'use strict';

const config = {
    messagingSenderId : ''  // Firebase consoleから取得した'messagingSenderId'を設定する
};

firebase.initializeApp(config);

// WindowControllerインスタンスを取得
const messaging = firebase.messaging();

// ブラウザがService Workerに対応しているか？
if (navigator.serviceWorker) {
    // Service Workerに対応していれば、Service Workerを登録する 
    navigator.serviceWorker.register('./firebase-messaging-sw.js').then(() => {
        return navigator.serviceWorker.ready;
    }).catch(() => {
        // Service Workerの登録に失敗した場合
    }).then(registration => {
        // Webプッシュ通知を受信するためにServiceWorkerRegistrationを登録する 
        messaging.useServiceWorker(registration);

        // 通知の許可 -> トークンの取得の順でないと、トークンの取得に失敗する 
        messaging.requestPermission().then(() => {
            // 通知許可の取得に成功した場合
            messaging.getToken().then(token => {
                const options = {
                    method  : 'POST',
                    headers : new Headers({ 'Content-Type' : 'application/json' }),
                    body    : JSON.stringify({ token })
                };

                // サーバへトークンをPOSTする
                fetch('/api/push/register', options).then(() => {
                    // トークンの送信に成功した場合
                }).catch(() => {
                    // トークンの送信に失敗した場合
                });
            }).catch(() => {
                // トークンの取得に失敗した場合
            });
        }).catch(() => {
            // 通知許可の取得に失敗した場合
        });
    });
}
